﻿--
-- kenworth
-- Specialization class for kenworth
--
-- @author  oxtar
-- @date  21/02/2013
--
-- Copyright (C) by oxtar-Modding, All Rights Reserved.
XML
	<tanklight index="0>15|16|1|4|4" index2="0>15|16|1|4|5"/>
	<handbrakelight index="0>15|16|1|4|6"/>
	<AirPress index="0>15|16|1|4|7"/>
	<BeaconRef index="0>15|16|1|6|8"/>
  <cabrun index="0>15|16|1|4|11"/>
	<ncabrun index="0>15|16|1|4|0"/>
	<tailrun index="0>15|11|6"/>
	<ntailrun index="0>15|11|0"/>
	<rotationCAB index="0>15|16|1" minRot="0 0 0" maxRot="75 0 0" rotTime="2.5" touchRotLimit="10" />
	
	
	
	
	Moddesc
	 <l10n>
	   
	
		<text name="tgm"><de>Knebel-Spiegel</de><en>Toggle Mirrors</en></text>
		<text name="ToggleMirror"><de>Knebel-Spiegel</de><en>Toggle Mirrors</en></text>
		<text name="TipCab"><de>Taxi-Tipp</de><en>Tip Cab</en></text>
		<text name="tcb"><de>Taxi-Tipp</de><en>Tip Cab</en></text>
    </l10n>
	
	<inputBindings>
     
	
		<input name="TipCab"       category="VEHICLE" key1="KEY_KP_divide"     key2="" button="" device="0" mouse="" />
		<input name="ToggleMirror"       category="VEHICLE" key1="KEY_l"     key2="" button="" device="0" mouse="" />
	</inputBindings>
	
	

kenworth = {};

function kenworth.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function kenworth:load(xmlFile)
	self.Mirror1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Mirror1#index"));
	self.Mirror2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Mirror2#index"));
	self.tanklight = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.tanklight#index"));
	self.tank2light = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.tanklight#index2"));
	self.AirPress = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.AirPress#index"));
	self.tanklightActive = false;
	self.tankwarn = 100;
	self.runningLight = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.runningLight#index"));
	self.nrunningLight = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.nrunningLight#index"));
	self.cabrun = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.cabrun#index"));
	self.ncabrun = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.ncabrun#index"));
	self.tailrun = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.tailrun#index"));
	self.ntailrun = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.ntailrun#index"));
	

	local rotationNodeCAB = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotationCAB#index"));
	if rotationNodeCAB ~= nil then
		self.rotationCAB = {};
		self.rotationCAB.node = rotationNodeCAB;

    local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationCAB#minRot"));
        self.rotationCAB.minRot = {};
        self.rotationCAB.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationCAB.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationCAB.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationCAB#maxRot"));
        self.rotationCAB.maxRot = {};
        self.rotationCAB.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationCAB.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationCAB.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationCAB.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationCAB#rotTime"), 2)*1000;
        self.rotationCAB.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationCAB#touchRotLimit"), 10));
	end;

	fuelwarningSoundFile = Utils.getFilename("sound/fuelwarning.ogg", self.baseDirectory);
    self.fuelwarningSoundId = createSample("fuelwarningSound");
    loadSample(self.fuelwarningSoundId, fuelwarningSoundFile, false);
    self.fuelwarningPlaying = false;
	self.druckLevel = 0;
	self.rotationMaxCAB = false;
	self.Mirror = false;
	setVisibility(self.tanklight,false);
	setVisibility(self.tank2light,false);
    setVisibility(self.Mirror1,false);
	setVisibility(self.Mirror2,false);
	
	brakeSoundFile = Utils.getFilename("sound/brake2.ogg", self.baseDirectory);
    self.brakeSoundId = createSample("brakeSound");
    loadSample(self.brakeSoundId, brakeSoundFile, false);
    self.brakePlaying = false;
	
	brakereleaseSoundFile = Utils.getFilename("sound/brake.ogg", self.baseDirectory);
    self.brakereleaseSoundId = createSample("brakereleaseSound");
    loadSample(self.brakereleaseSoundId, brakereleaseSoundFile, false);
    self.brakereleasePlaying = false;
		
	compressorSoundFile = Utils.getFilename("sound/compressor.ogg", self.baseDirectory);
    self.compressorSoundId = createSample("compressorSound");
    loadSample(self.compressorSoundId, compressorSoundFile, false);
    self.compressorPlaying = false;
	
	compressorstopSoundFile = Utils.getFilename("sound/compressorstop.ogg", self.baseDirectory);
    self.cssi = createSample("compressorstopSound");
    loadSample(self.cssi, compressorstopSoundFile, false);
    self.compressorstopPlaying = false;

end;

function kenworth:delete()
	if self.fuelwarningSoundId ~= nil then
		delete(self.fuelwarningSoundId);
	end;
	if self.brakeSoundId ~= nil then
		delete(self.brakeSoundId);
	end;
	if self.brakereleaseSoundId ~= nil then
		delete(self.brakereleaseSoundId);
	end;
	if self.compressorSoundId ~= nil then
		delete(self.compressorSoundId);
	end;
	if self.cssi ~= nil then
		delete(self.cssi);
	end;
end;

function kenworth:mouseEvent(posX, posY, isDown, isUp, button)

end;

function kenworth:keyEvent(unicode, sym, modifier, isDown)
if self:getIsActiveForInput() then
	if Input.isKeyPressed(Input.KEY_KP_divide) then
		self.rotationMaxCAB = not self.rotationMaxCAB;
	end;
	
	if Input.isKeyPressed(Input.KEY_l) then
		self.Mirror = not self.Mirror;
		setVisibility(self.Mirror1, self.Mirror);
		setVisibility(self.Mirror2, self.Mirror);
	end;
end;	

end;

function kenworth:updateTick(dt)

end;

function kenworth:update(dt)
	if self.lightsTypesMask ~= 0 then
		setVisibility(self.runningLight, true);
		setVisibility(self.nrunningLight, false);
		setVisibility(self.cabrun, true);
		setVisibility(self.ncabrun, false);
		setVisibility(self.tailrun, true);
		setVisibility(self.ntailrun, false);
		
	else
		setVisibility(self.nrunningLight, true);
		setVisibility(self.runningLight, false);
		setVisibility(self.ncabrun, true);
		setVisibility(self.cabrun, false);
		setVisibility(self.ntailrun, true);
		setVisibility(self.tailrun, false);
	end;
	setVisibility(self.AirPress, self.druckWarning);
	
	if self.rotationCAB ~= nil then
		local x, y, z = getRotation(self.rotationCAB.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationCAB.maxRot, self.rotationCAB.minRot, 3, self.rotationCAB.rotTime, dt, not self.rotationMaxCAB);
		setRotation(self.rotationCAB.node, unpack(newRot));
	end;

	if self.isEntered then
		if self.fuelFillLevel < 75 then
			self.tankwarn = self.tankwarn - dt;
			if self.tankwarn <= 0 then
				playSample(self.fuelwarningSoundId,1,1,0);
				self.tankwarn = 30000;
			end;
			self.tanklightActive = true;
		else
			self.tankwarn = 30000;
			self.tanklightActive = false;
		end;
		setVisibility(self.tanklight,self.tanklightActive);
		setVisibility(self.tank2light,self.tanklightActive);
	end;
	
	if self.isMotorStarted then        
		if Input.isKeyPressed(Input.KEY_s) then
			if self.druckLevel >= 3500 then
				if not self.braking then
					if self.attachedTrailer then
						self.druckLevel = self.druckLevel -500;
					else
						self.druckLevel = self.druckLevel -300;
					end;
					self.braking = true;
				end;
				if not self.brakePlaying and self:getIsActiveForSound() then
					playSample(self.brakeSoundId,1,1,0);
					self.brakePlaying = true;
				end;
				self.brakereleasePlaying = false;				
			end;
		else
			self.brakePlaying = false;
			self.braking = false;
			if not self.brakereleasePlaying and self:getIsActiveForSound() then
				playSample(self.brakereleaseSoundId,1,1,0);
				self.brakereleasePlaying = true;
			end;
		end;
			
		if self.druckLevel >= -1 and self.druckLevel <= 6100 then
			self.compressorStart = true;
		end;
		if self.druckLevel >= 9999 then
			self.compressorStart = false;
		end;
		if self.compressorStart == true then
			if not self.compressorSoundRunning and self:getIsActiveForSound() then
				playSample(self.compressorSoundId, 0, 1, 0);
				self.compressorSoundRunning = true;
			end;
			self.compressorstopSoundRunning = false;
			if self.druckLevel <= 10000 then
				self.druckLevel = self.druckLevel +(dt/3);
			end;
		end;
		if self.compressorStart == false then
			stopSample(self.compressorSoundId, 0, 1, 0);
			self.compressorSoundRunning = false;
			if not self.compressorstopSoundRunning and self:getIsActiveForSound() then
				playSample(self.cssi, 1, 1, 0);
				self.compressorstopSoundRunning = true;
			end;
			if self.druckLevel >= 6099 then
				self.druckLevel = self.druckLevel -(dt/40);
			end;
		end;
		if self.druckLevel <= 6000 then
			self.druckWarning = true;
			self.drucklightActive = true;
		else
			self.druckWarning = false;
			self.drucklightActive = false;
		end;
	else
	stopSample(self.compressorSoundId, 0, 1, 0);
	end;
end;

function kenworth:draw()

	if self.isEntered and self:getIsActiveForInput() then
		g_currentMission:addHelpButtonText(g_i18n:getText("tgm"), InputBinding.ToggleMirror);
		g_currentMission:addHelpButtonText(g_i18n:getText("tcb"), InputBinding.TipCab);
	end;

end;

function kenworth:onEnter()
	
end;

function kenworth:onLeave()
    stopSample(self.compressorSoundId, 0, 1, 0);
    self.compressorSoundRunning = false;
end;